<?php


namespace App\Http\Controllers;



use App\Models\CdmsUsers;
use App\Models\CommunitySchedule;
use App\Models\Docter;
use App\Models\DocterOrganization;
use App\Models\DocterSetting;
use App\Models\Order;
use App\Models\Organization;
use App\Models\Schedule;
use App\Models\SchedulePeriod;
use App\Models\SelfSchedule;
use App\Models\SystemConfig;
use App\Models\TimePeriod;
use App\Models\WeekSchedule;
use Carbon\Carbon;
use Encore\Admin\Admin;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Log;
use mysql_xdevapi\Exception;
use phpDocumentor\Reflection\DocBlock\Description;

class ScheDuleController  extends Controller
{

    public function __construct()
    {

        // 允许 $originarr 数组内的 域名跨域访问

        header('Access-Control-Allow-Origin:*');

        // 响应类型

        header('Access-Control-Allow-Methods:POST,GET');

        // 带 cookie 的跨域访问

        header('Access-Control-Allow-Credentials: true');

        // 响应头设置

        header('Access-Control-Allow-Headers:x-requested-with,Content-Type,X-CSRF-Token');

    }

    //获取排班页面
    public function getComScheduleback()
    {

        $set_time = request('time');//时间
        $org_id = request('org_id');//机构
        $docter_id = request('docter_id');//医生


//        $set_time = '2020-11-30至2020-12-06';
//        $org_id = 1;
//        $docter_id = 47;
        $role = 2;

        if(empty($set_time) || empty($org_id) || empty($docter_id)){
            return json_encode(['status'=>601,'msg'=>'缺少必要参数','data'=>'']);
        } else{
//            echo 'what happend';
        }


        $all_time = explode('至',$set_time);
        if(count($all_time) <2){
            return json_encode(['status'=>601,'msg'=>'缺少必要参数','data'=>'']);
        }

        $start_time  = intval(str_replace('-','',$all_time[0]));
        $end_time  = intval(str_replace('-','',$all_time[1]));
        $first_day = strtotime($all_time[0]);
//        DB::enableQueryLog();
        $sche_dule = Schedule::whereBetween('schedule_day',[$start_time,$end_time])
                                ->where(['docter_id'=>$docter_id])
                                ->pluck('id')
                                ->toArray();
//        echo '<pre>';
//        print_r(DB::getQueryLog());
//        echo '</pre>';
        //dd($sche_dule);

        $sche_dule_arr =[
            [
                'date'=>"上午",
                'monday'=>false,
                'tuesday'=>false,
                'wednesday'=>false,
                'thursday'=>false,
                'friday'=>false,
                'saturday'=>false,
                'sunday'=>false,
            ],
            [
                'date'=>"下午",
                'monday'=>false,
                'tuesday'=>false,
                'wednesday'=>false,
                'thursday'=>false,
                'friday'=>false,
                'saturday'=>false,
                'sunday'=>false,
            ],
            [
                'date'=>"晚上",
                'monday'=>false,
                'tuesday'=>false,
                'wednesday'=>false,
                'thursday'=>false,
                'friday'=>false,
                'saturday'=>false,
                'sunday'=>false,
            ]
        ];

        //周字段映射
        $week_arr = ['monday','tuesday','wednesday','thursday','friday','saturday','sunday'];

        //时段区间id
        $schedule_config = SystemConfig::get('docter_config');
        $times[] = TimePeriod::where('start_time_period','>=',$schedule_config['morning_start'])->where('end_time_period','<=',$schedule_config['morning_end'])->pluck('id')->toArray();
        $times[] = TimePeriod::where('start_time_period','>=',$schedule_config['afternoon_start'])->where('end_time_period','<=',$schedule_config['afternoon_end'])->pluck('id')->toArray();
        $times[] = TimePeriod::where('start_time_period','>=',$schedule_config['evening_start'])->where('end_time_period','<=',$schedule_config['evening_end'])->pluck('id')->toArray();
        if(empty($sche_dule)){
            return ['status'=>200,'msg'=>'ok','data'=>['docter'=>$sche_dule_arr,'org_id'=>$org_id,'docter_id'=>$docter_id]];
        }

        $role = 2;
        if($role == 1){
            $ids = DocterOrganization::where(['organization_id'=>$org_id])->pluck('docter_id');
            $list = Docter::whereIn('id',$ids)->get(['id as value','name as label'])->toArray();
            $name = Organization::where('id',$docter_id)->value('name');

            $user_id = $org_id;
            for ($i = 1; $i<7; $i++){
                $str_time =  date('Y-m-d',($first_day + $i * 86400));
                for($j=0;$j<3;$j++){
                    //检测上午
                    $is_mo_have = SchedulePeriod::whereIn('schedule_id',$sche_dule)->where('schedule_date',$str_time)->whereIn('time_period_id',$times[$j])
                        ->where('organization_id','!=',$org_id)->count();
                    ['schedule_id'=>$sche_dule,'schedule_date'=>$str_time,'organization_id'=>$org_id,'docter_id'=>$docter_id];

                    $is_self = SchedulePeriod::whereIn('schedule_id',$sche_dule)->where('schedule_date',$str_time)->whereIn('time_period_id',$times[$j])
                        ->where('organization_id',$org_id)->count();

                    if($is_self){
                        $sche_dule_arr[$j][$week_arr[$i]] = true;
                    }
                    if($is_mo_have){
                        $sche_dule_arr[$j][$week_arr[$i]] = 'other';
                    }
                }
            }
        } else {

            $ids = DocterOrganization::where(['docter_id'=>$docter_id])->pluck('organization_id');
            $list = Organization::whereIn('id',$ids)->get(['id as value','name as label'])->toArray();
            $name = Docter::where('id',$docter_id)->value('name');
            $user_id = $docter_id;
            for ($i=0; $i<=6; $i++){
                $str_time =  date('Y-m-d',($first_day + $i * 86400));
                for($j=0;$j<=2;$j++){
                    //检测上午
                    $is_mo_have = SchedulePeriod::whereIn('schedule_id',$sche_dule)->where('schedule_date',$str_time)->whereIn('time_period_id',$times[$j])
                        ->where('organization_id','!=',$org_id)->where('docter_id','=',$docter_id)->count();
                    $is_mo_self = SchedulePeriod::whereIn('schedule_id',$sche_dule)->where('schedule_date',$str_time)->whereIn('time_period_id',$times[$j])
                        ->where('organization_id',$org_id)->where('docter_id',$docter_id)->count();
//                    echo $i.'--'.$j.'is_self---'.$is_mo_self.'<br>';

                    if($is_mo_self){
                        $sche_dule_arr[$j][$week_arr[$i]] = true;
                    }
                    if($is_mo_have){
                        $sche_dule_arr[$j][$week_arr[$i]] = 'other';
                    }
                }
            }
        }


        //  "morning_start" => "09:00"
        //  "morning_end" => "12:00"
        //  "afternoon_start" => "13:00"
        //  "afternoon_end" => "18:00"
        //  "evening_start" => "19:00"
        //  "evening_end" => "20:00"


        $data['docter'] = $sche_dule_arr;
        $data['name'] = $name;
//        $data['list'] = $list;

        $data['role'] = $role;
        $data['user_id'] = $user_id;
        return  (json_encode(['code'=>200,'msg'=>'ok','data'=>$data]));
    }

    //获取周排班
    public function getComSchedule(){
        $docter_id = request('docter_id',1);
        $org_id = request('org_id',1);
        $type = request('type',2);
        $role = request('role',2);
        if(empty($docter_id) || empty($type)){
            return apiReturn(604,'缺少必要参数');
        }

        $docter_id = 1;
        $docter_setting = DocterSetting::where(['docter_id'=>$docter_id,'type'=>$type])->first();
        $times = [];
        if(!empty($docter_setting)){
            $time_period = object_array(json_decode($docter_setting->service_time));
            $times[] = TimePeriod::where(['docter_id'=>$docter_id])->whereBetween('end_time_period',[intval($time_period[0]['startTime']),intval($time_period[0]['endTime'])])->pluck('id')->toArray();
            $times[] = TimePeriod::where(['docter_id'=>$docter_id])->whereBetween('end_time_period',[intval($time_period[1]['startTime']),intval($time_period[1]['endTime'])])->pluck('id')->toArray();
            $times[] = TimePeriod::where(['docter_id'=>$docter_id])->whereBetween('end_time_period',[intval($time_period[2]['startTime']),intval($time_period[2]['endTime'])])->pluck('id')->toArray();
        }

        if(count($times) < 3){
            dd('no have times');
        }

        //周字段映射
        $week_arr = ['monday','tuesday','wednesday','thursday','friday','saturday','sunday'];
        $data = [
            [
                'date'=>"上午",
                'monday'=>false,
                'tuesday'=>false,
                'wednesday'=>false,
                'thursday'=>false,
                'friday'=>false,
                'saturday'=>false,
                'sunday'=>false,
            ],
            [
                'date'=>"下午",
                'monday'=>false,
                'tuesday'=>false,
                'wednesday'=>false,
                'thursday'=>false,
                'friday'=>false,
                'saturday'=>false,
                'sunday'=>false,
            ],
            [
                'date'=>"晚上",
                'monday'=>false,
                'tuesday'=>false,
                'wednesday'=>false,
                'thursday'=>false,
                'friday'=>false,
                'saturday'=>false,
                'sunday'=>false,
            ]
        ];
        if($role == 2){
            for ($i=0;$i<6;$i++){
                for($j=0;$j<=2;$j++){
                    $is_self_have = WeekSchedule::where(['docter_id'=>$docter_id,'schedule_type'=>$type,'organization_id'=>$org_id,'week'=>$i+1])->whereIn('time_period_id',$times[$j])->count();
                    $is_other_have = WeekSchedule::where(['docter_id'=>$docter_id,'schedule_type'=>$type,'week'=>$i+1])->where('organization_id','!=',$org_id)->whereIn('time_period_id',$times[$j])->count();
                    if($is_self_have){
                        $data[$j][$week_arr[$i]] = true;
                    }
                    if($is_other_have){
                        $data[$j][$week_arr[$i]] = 'other';
                    }
                }
            }
        } else {
            for ($i=0;$i<6;$i++){
                for($j=0;$j<=2;$j++){
                    $is_self_have = WeekSchedule::where(['docter_id'=>$docter_id,'schedule_type'=>$type,'organization_id'=>$org_id,'week'=>$i+1])->whereIn('time_period_id',$times[$j])->count();
                    $is_other_have = WeekSchedule::where(['docter_id'=>$docter_id,'schedule_type'=>$type,'week'=>$i+1])->where('docter_id','!=',$docter_id)->whereIn('time_period_id',$times[$j])->count();
                    if($is_self_have){
                        $data[$j][$week_arr[$i]] = true;
                    }
                    if($is_other_have){
                        $data[$j][$week_arr[$i]] = 'other';
                    }
                }
            }
        }

        $name = Docter::where('id',$docter_id)->value('name');

        $shcedule_data['docter'] = $data;
        $shcedule_data['name'] = $name;

        $shcedule_data['role'] = $role;
        $shcedule_data['user_id'] = $docter_id;

        return apiReturn(200,'ok',$shcedule_data);
    }

    //编辑排班
    public function setDocCheduleback()
    {
        $docter_id = request('docter_id');
        $org_id = request('org_id');
        $set_time = request('time');
        $data = request('schedulingtime');
//        $set_time = '2020-12-07至2020-12-13';
        if(empty($set_time) || empty($org_id) || empty($docter_id)){
            return json_encode(['status'=>601,'msg'=>'缺少必要参数','data'=>'']);
        }

        $all_time = explode('至',$set_time);
        $schedule_id = Schedule::where(['organization_id'=>$org_id,'docter_id'=>$docter_id,'schedule_date'=>$all_time[0]])->value('id');
        if(count($all_time) <2) {
            return json_encode(['status'=>601,'msg'=>'缺少必要参数','data'=>'']);
        }
        $start_time  = intval(str_replace('-','',$all_time[0]));
        $end_time  = intval(str_replace('-','',$all_time[1]));
        $first_day = strtotime($start_time);
        //周字段映射
        $week_arr = ['monday','tuesday','wednesday','thursday','friday','saturday','sunday'];
//        $data = [
//            [
//                'date'=>"上午",
//                'monday'=>false,
//                'tuesday'=>false,
//                'wednesday'=>false,
//                'thursday'=>true,
//                'friday'=>false,
//                'saturday'=>false,
//                'sunday'=>false,
//            ],
//            [
//                'date'=>"下午",
//                'monday'=>false,
//                'tuesday'=>true,
//                'wednesday'=>false,
//                'thursday'=>false,
//                'friday'=>false,
//                'saturday'=>false,
//                'sunday'=>false,
//            ],
//            [
//                'date'=>"晚上",
//                'monday'=>false,
//                'tuesday'=>false,
//                'wednesday'=>true,
//                'thursday'=>false,
//                'friday'=>false,
//                'saturday'=>false,
//                'sunday'=>false,
//            ]
//        ];


        //时段区间id
        $schedule_config = SystemConfig::get('docter_config');
        $times[1] = TimePeriod::where('start_time_period','>=',$schedule_config['morning_start'])
                        ->where('end_time_period','<=',$schedule_config['morning_end'])
                        ->pluck('id')->toArray();

        $times[2] = TimePeriod::where('start_time_period','>=',$schedule_config['afternoon_start'])
                        ->where('end_time_period','<=',$schedule_config['afternoon_end'])
                        ->pluck('id')->toArray();

        $times[3] = TimePeriod::where('start_time_period','>=',$schedule_config['evening_start'])
                        ->where('end_time_period','<=',$schedule_config['evening_end'])
                        ->pluck('id')->toArray();
        foreach ($times as $val){
            foreach ($val as $t){
                $time_period[] = $t;
            }
        }

        $data[0] = array_values(object_array(json_decode($data[0])));
        $data[1] = array_values(object_array(json_decode($data[1])));
        $data[2] = array_values(object_array(json_decode($data[2])));

        $mo_schedule = array_values($data[0]);
        $af_schedule = array_values($data[1]);
        $ev_schedule = array_values($data[2]);


        DB::beginTransaction();
        try {
            $schedule_insert = [
                'organization_id'=>$org_id,
                'docter_id'=>$docter_id,
                'schedule_date'=>$all_time[0],
                'schedule_day'=>$start_time,
                'created_at'=>Carbon::now(),
                'updated_at'=>Carbon::now(),
            ];
            if(!$schedule_id){
                $schedule_id = Schedule::insertGetId($schedule_insert);
            }
            unset($schedule_insert['schedule_day']);
            $schedule_insert['schedule_id'] =$schedule_id;
            $info = [];
            for ($i = 1 ;$i<=3;$i++){
                $mo_schedule = array_values($data[$i-1]);
                foreach ($mo_schedule as $key=>$val){
                    if($key==0) continue;
                    $schedule_date = $start_time + $key;
                    $strtime = "$schedule_date";
                    $time_insert = $schedule_insert;
                    $time_insert['type'] = $i;

                    $schedule_time = $times[$i];
                    $real_time = date('Y-m-d',($first_day + ($key-1)*86400));
                    $time_insert['schedule_date'] = $real_time;
                    $time_insert['me_sure'] = 1;

                    if($val == true){
                        $data['schedule_date'] = $start_time ;

                        foreach ($schedule_time as $time_id){
                            $is_have = SchedulePeriod::where(['time_period_id'=>$time_id,'type'=>($i),'docter_id'=>$docter_id,'schedule_date'=>$real_time,'organization_id'=>$org_id,'docter_id'=>$docter_id,'schedule_id'=>$schedule_id])->value('id');
                            if($is_have) break;
                            $time_insert['time_period_id'] = $time_id;
                            $info[] = $time_insert;
                            SchedulePeriod::insert($time_insert);
                        }
                    } else {
                        $data['schedule_date'] = $start_time;
                        foreach ($schedule_time as $time_id){
                            $is_have = SchedulePeriod::where(['time_period_id'=>$time_id,'type'=>($i),'docter_id'=>$docter_id,'schedule_date'=>$real_time,'organization_id'=>$org_id,'docter_id'=>$docter_id,'schedule_id'=>$schedule_id])->value('id');
                            if($is_have)  SchedulePeriod::where(['time_period_id'=>$time_id,'type'=>($i),'docter_id'=>$docter_id,'schedule_date'=>$real_time,'organization_id'=>$org_id,'docter_id'=>$docter_id,'schedule_id'=>$schedule_id])->delete();
                        }
                    }
                }
            }
            DB::commit();
        } catch (Exception $e){
            DB::rollBack();
            Log::info($e->getMessage());
        }
        return json_encode(['status'=>200,'msg'=>'插入成功','data'=>count($info)]);
    }

    public function setDocChedule()
    {
        $docter_id = request('docter_id',1);
        $org_id = request('org_id',1);
        $type = request('type',2);
        if(empty($docter_id) || empty($org_id) || empty($type)){
            return apiReturn(601,'缺少必要参数');
        }
        $data = request('schedulingtime');
        if(empty($org_id) || empty($docter_id) || $data){
            return json_encode(['status'=>601,'msg'=>'缺少必要参数','data'=>'']);
        }

        $docter_setting = DocterSetting::where(['docter_id'=>$docter_id])->first();
//        $data = [
//            [
//                'date'=>"上午",
//                'monday'=>false,
//                'tuesday'=>true,
//                'wednesday'=>false,
//                'thursday'=>false,
//                'friday'=>true,
//                'saturday'=>false,
//                'sunday'=>false,
//            ],
//            [
//                'date'=>"下午",
//                'monday'=>false,
//                'tuesday'=>false,
//                'wednesday'=>false,
//                'thursday'=>false,
//                'friday'=>false,
//                'saturday'=>true,
//                'sunday'=>false,
//            ],
//            [
//                'date'=>"晚上",
//                'monday'=>true,
//                'tuesday'=>true,
//                'wednesday'=>false,
//                'thursday'=>false,
//                'friday'=>false,
//                'saturday'=>false,
//                'sunday'=>false,
//            ]
//        ];
        if(!empty($docter_setting)){
            $time_period = object_array(json_decode($docter_setting->service_time));
            $times[] = TimePeriod::where(['docter_id'=>$docter_id])->whereBetween('end_time_period',[intval($time_period[0]['startTime']),intval($time_period[0]['endTime'])])->pluck('id')->toArray();
            $times[] = TimePeriod::where(['docter_id'=>$docter_id])->whereBetween('end_time_period',[intval($time_period[1]['startTime']),intval($time_period[1]['endTime'])])->pluck('id')->toArray();
            $times[] = TimePeriod::where(['docter_id'=>$docter_id])->whereBetween('end_time_period',[intval($time_period[2]['startTime']),intval($time_period[2]['endTime'])])->pluck('id')->toArray();
        }


        $week_data = [
            'schedule_type'=>$type,
            'organization_id'=>$org_id,
            'docter_id'=>$docter_id
        ];
        $k = 0;
        DB::beginTransaction();
        $data[0] = array_values(object_array(json_decode($data[0])));
        $data[1] = array_values(object_array(json_decode($data[1])));
        $data[2] = array_values(object_array(json_decode($data[2])));


//        $data[0] = array_values($data[0]);
//        $data[1] = array_values($data[1]);
//        $data[2] = array_values($data[2]);
        try {
            for($i=0;$i<=2;$i++){
                $schedule_data = $data[$i];
                foreach ($schedule_data as $key=>$schedule){
                    if($key == 0) continue;
                    $week_data ['type'] = $i+1;
                    $week_data ['week'] = $key;
                    if($schedule == true){
//                        echo '时间列类型'.($i+1).'----'.$key.'星期数'.'<br>';
                        foreach ($times[$i] as $id){
                            $week_data['time_period_id'] = $id;
                            $is_have = WeekSchedule::where(['docter_id'=>$docter_id,'organization_id'=>$org_id,'schedule_type'=>$type,'type'=>$i+1,'week'=>$key])->where('time_period_id',$id)->value('id');
                            $is = $is_have?'有':'沒有';
//                            echo '时间段id'.$id.'----'.$is.'</br>';
                            if($is_have) continue;
                            $k++;
                            WeekSchedule::insert($week_data);
                        }
                    } else {
                        $is_have = WeekSchedule::where(['docter_id' => $docter_id, 'organization_id' => $org_id, 'schedule_type' => $type,'type'=>$i+1,'week'=>$key])->whereIn('time_period_id', $times[$i])->value('id');
                        if($is_have) WeekSchedule::where(['docter_id' => $docter_id, 'organization_id' => $org_id, 'schedule_type' => $type,'type'=>$i+1,'week'=>$key])->whereIn('time_period_id', $times[$i])->delete();
                    }

                }
            }
            DB::commit();
        } catch (\Exception $e){
            DB::rollBack();
            return apiReturn(602,$e->getLine().'行'.$e->getMessage());
        }
        return apiReturn(200,'ok',$k);
    }

    //设置自己排班
    public function setSelfSchedule()
    {
        $docter_id = request('docter_id');
        $org_id = request('org_id');
        $date = request('date');
        $type = request('type','1,2'); //1 上午，2 下午，3 晚上
        $schedule_type = request('schedule_type');
        $self_setting = DocterSetting::where(['docter_id'=>$docter_id])->first();
        $times = [];
        if(!empty($self_setting)){
            $time_period = object_array(json_decode($self_setting->service_time));
            $times[1] = TimePeriod::where(['docter_id'=>$docter_id])->whereBetween('end_time_period',[intval($time_period[0]['startTime']),intval($time_period[0]['endTime'])])->pluck('id')->toArray();
            $times[2] = TimePeriod::where(['docter_id'=>$docter_id])->whereBetween('end_time_period',[intval($time_period[1]['startTime']),intval($time_period[1]['endTime'])])->pluck('id')->toArray();
            $times[3] = TimePeriod::where(['docter_id'=>$docter_id])->whereBetween('end_time_period',[intval($time_period[2]['startTime']),intval($time_period[2]['endTime'])])->pluck('id')->toArray();
        }
        if(count($times) <3){
            return apiReturn(602,'请设置真确的时间段');
        }

        if(empty($docter_id) || empty($org_id) || empty('date') || empty($type) || empty($schedule_type)){
            return apiReturn(601,'缺少必要参数');
        }

        if(strtotime($date) < strtotime('tomorrow')){
            return apiReturn(602,'只能排明天以後的');
        }

        $week = date("w",strtotime($date));
        $types = explode(',',$type);
        if(!empty($types)){
            foreach ($types  as $t){
                $self_schedule = [
                    'schedule_date'=>$date,
                    'week'=>intval($week),
                    'schedule_type'=>$schedule_type,
                    'organization_id'=>$org_id,
                    'docter_id'=>$docter_id,
                    'type'=>intval($t)
                ];
                foreach ($times[intval($t)] as $id){
                    $self_schedule['time_period_id'] = $id;
                    $is_have = SelfSchedule::where(['docter_id'=>$docter_id,'organization_id'=>$org_id,'schedule_date'=>$date,'type'=>intval($t),'week'=>$week,'time_period_id'=>$id])->value('id');
                    if($is_have) continue;
                    SelfSchedule::insert($self_schedule);
                }
            }

            $cha = array_diff([1,2,3],$types);
            foreach ($cha as $t){
                SelfSchedule::where(['docter_id'=>$docter_id,'organization_id'=>$org_id,'schedule_date'=>$date,'type'=>intval($t)])->delete();
            }
        }
        return apiReturn(200,'ok');
    }

    //更新用戶設置
    public function updateDocterSetting()
    {
        $docter_id = request('docter_id',1);
        $configData = request('configData');
        $type = request('type');
        if(empty($docter_id) || empty($configData)){
            return apiReturn(604,'参数错误');
        }

        $configData = object_array(json_decode($configData));
//        $configData = [
//            'amEndTime'=>"11:30",
//            'amNum'=>20,
//            'amStartTime'=>"09:00",
//            'nightEndTime'=>"19:30",
//            'nightNum'=>8,
//            'nightStartTime'=>"11:30",
//            'pmEndTime'=>"16:00",
//            'pmNum'=>20,
//            'pmStartTime'=>"13:30",
//            'serviceNum'=>2,
//            'status'=>false,
//            'timeSpan'=>15,
//        ];

//        configData: {
//                amEndTime: "11:30",    //上午结束时间  string
//        amNum: 20,  //上午号源 Num
//        amStartTime: "09:00",   //上午开始时间  string
//        nightEndTime: "19:30",    //晚上结束时间   string
//        nightNum: 8,  //晚上号源  num
//        nightStartTime: "18:30",   //晚上开始时间 staring
//        pmEndTime: "16:00",   //下午结束时间   string
//        pmNum: 20,   //下午号源   num
//        pmStartTime: "13:30",   //下午开始时间  string
//        serviceNum: 2,    //同时服务人数   Num
//        showDayNumber: 7,   //可预约服务天数  Num
//        status: false,   //  是否开启  true false
//        timeSpan: "15",   // 就诊时长  string
//      },
        $setting  = DocterSetting::where(['docter_id'=>$docter_id])->first()->toArray();

        $self_config = object_array(json_decode($setting['service_time']));
        $is_new = [];
//
//        if(intval($configData['timeSpan']) != $setting['service_num']){
//            $is_new[] = 4 ;
//        }
//
//        if($configData['amStartTime'] != $self_config[1]['amStartTime'] ||  $configData['amEndTime'] != $self_config[1]['amEndTime']){
//            $is_new[] = 1;
//        }
//
//        if($configData['pmStartTime'] != $self_config[2]['pmStartTime'] ||  $configData['pmEndTime'] != $self_config[2]['pmEndTime']){
//            $is_new[] = 2;
//        }
//
//        if($configData['nightStartTime'] != $self_config[3]['nightStartTime'] ||  $configData['nightEndTime'] != $self_config[3]['nightEndTime']){
//            $is_new[] = 3;
//        }
//
//        configData: {
//                amEndTime: "11:30",    //上午结束时间  string
        //        amNum: 20,  //上午号源 Num
        //        amStartTime: "09:00",   //上午开始时间  string
        //        nightEndTime: "19:30",    //晚上结束时间   string
        //        nightNum: 8,  //晚上号源  num
        //        nightStartTime: "18:30",   //晚上开始时间 staring
        //        pmEndTime: "16:00",   //下午结束时间   string
        //        pmNum: 20,   //下午号源   num
        //        pmStartTime: "13:30",   //下午开始时间  string
        //        serviceNum: 2,    //同时服务人数   Num
        //        showDayNumber: 7,   //可预约服务天数  Num
        //        status: false,   //  是否开启  true false
        //        timeSpan: "15",   // 就诊时长  string
//      },
        //添加时间段
        $is_new = [1];
        if(count($is_new) > 5){
//            $data = ['docter_id'=>$docter_id,'am_start'=>'8:30','am_end'=>'11:30','pm_start'=>'12:00','pm_end'=>'15:00','ev_start'=>'19:00','ev_end'=>'22:00','service_time'=>15];
//            $amtimes[] = explode(':',$configData['amStartTime']);
//            $amtimes[] = explode(':',$configData['amEndTime']);
//            $amcha = ($amtimes[1][0] - $amtimes[0][0])*60 +($amtimes[1][1] - $amtimes[0][1]);
//            $amCount = $amcha/$data['service_time'];
//            $amCount = intval(floor((strtotime($configData['amEndTime']) - strtotime($configData['amStartTime'])) / (60*$configData['timeSpan'])));

//            $pmtimes[] = explode(':',$configData['pmStartTime']);
//            $pmtimes[] = explode(':',$configData['pmEndTime']);
//            $pmCount =intval(floor((strtotime($configData['pmEndTime']) - strtotime($configData['pmStartTime'])) / (60*$configData['timeSpan'])));
//
//
//            $evtimes[] = explode(':',$configData['nightStartTime']);
//            $evtimes[] = explode(':',$configData['nightEndTime']);
//            $evcha = ($evtimes[1][0] - $evtimes[0][0])*60 +($evtimes[1][1] - $evtimes[0][1]);
//            $evCount = $evcha/$configData['service_time'];
            $amCount = $configData['amNum'];
            $pmCount = $configData['pmNum'];
            $evCount = $configData['nightNum'];


            $today_id = Schedule::where(['docter_id'=>$docter_id])->where('schedule_date','=',date('Y-m-d'))->value('id');
            if(in_array(4,$is_new)){
                TimePeriod::where(['docter_id'=>$docter_id])->delete();
                $schuedule_ids = Schedule::where(['docter_id'=>$docter_id])->where(['schedule_date','>',date('Y-m-d')])->pluck('id')->toArray();
                SchedulePeriod::where(['docter_id'=>$docter_id])->whereIn('schedule_id',$schuedule_ids)->delete();

                for($i=1;$i<=$amCount;$i++){
                    $amdata = [
                        'docter_id'=>$docter_id,
                        'start_time_period'=> date('H:i',strtotime($configData['amStartTime']) + ($i-1)*$configData['timeSpan']*60),
                        'end_time_period'=> date('H:i',strtotime($configData['amStartTime']) + $i*$configData['timeSpan']*60),
                    ];
                    TimePeriod::insert($amdata);
                }

                for($i=1;$i<=$pmCount;$i++){
                    $pmdata = [
                        'docter_id'=>$docter_id,
                        'start_time_period'=> date('H:i',strtotime($configData['pmStartTime']) + ($i-1)*$configData['timeSpan']*60),
                        'end_time_period'=> date('H:i',strtotime($configData['pmStartTime']) + $i*$configData['timeSpan']*60),
                    ];
                    TimePeriod::insert($pmdata);
                }

                for($i=1;$i<=$evCount;$i++){
                    $evdata = [
                        'docter_id'=>$docter_id,
                        'start_time_period'=> date('H:i',strtotime($configData['nightStartTime']) + ($i-1)*$configData['timeSpan']*60),
                        'end_time_period'=> date('H:i',strtotime($configData['nightStartTime']) + $i*$configData['timeSpan']*60),
                    ];
                    TimePeriod::insert($evdata);
                }
            } else {
                if(in_array(1,$is_new)){

                    TimePeriod::where(['docter_id'=>$docter_id,'type'=>1])->delete();
                    $old_ids = SelfSchedule::where(['docter_id'=>$docter_id,'type'=>1])->distinct('week')->pluck('week','type')->toArray();

                    $schedule_ids = Schedule::where(['docter_id'=>$docter_id])->where(['schedule_date','>',date('Y-m-d')])->pluck('id')->toArray();
                    SelfSchedule::where(['docter_id'=>$docter_id,'type'=>1])->whereIn('schedule_id',$schedule_ids)->delete();

                    SchedulePeriod::where(['docter_id'=>$docter_id])->whereIn('schedule_id',$schedule_ids)->delete();
                    for($i=1;$i<=$amCount;$i++){
                        $amdata = [
                            'docter_id'=>$docter_id,
                            'start_time_period'=> date('H:i',strtotime($configData['amStartTime']) + ($i-1)*$configData['timeSpan']*60),
                            'end_time_period'=> date('H:i',strtotime($configData['amStartTime']) + $i*$configData['timeSpan']*60),
                        ];
                        TimePeriod::insert($amdata);
                    }
                }

                if(in_array(2,$is_new)){
                    for($i=1;$i<=$pmCount;$i++){
                        $pmdata = [
                            'docter_id'=>$docter_id,
                            'start_time_period'=> date('H:i',strtotime($configData['pmStartTime']) + ($i-1)*$configData['timeSpan']*60),
                            'end_time_period'=> date('H:i',strtotime($configData['pmStartTime']) + $i*$configData['timeSpan']*60),
                        ];
                        TimePeriod::insert($pmdata);
                    }
                }

                if(in_array(2,$is_new)) {
                    for($i=1;$i<=$evCount;$i++){
                        $evdata = [
                            'docter_id'=>$docter_id,
                            'start_time_period'=> date('H:i',strtotime($configData['nightStartTime']) + ($i-1)*$configData['timeSpan']*60),
                            'end_time_period'=> date('H:i',strtotime($configData['nightStartTime']) + $i*$configData['timeSpan']*60),
                        ];
                        TimePeriod::insert($evdata);
                    }
                }
            }
        }
//        {"1":{"amStartTime":"08:00","amEndTime":"12:00","amPerson":3},"2":{"pmStartTime":"14:00","pmEndTime":"18:00","pmPerson":5},"3":{"nightStartTime":"18:00","nightEndTime":"23:00","nightPerson":4}}
        $config = [
            1=>['amStartTime'=>$configData['amStartTime'],"amEndTime"=>$configData['amEndTime'],'amPerson'=>$configData['amNum']],
            2=>["pmStartTime"=>$configData['pmStartTime'],"pmEndTime"=>$configData['pmEndTime'],'pmPerson'=>$configData['pmNum']],
            3=>["nightStartTime"=>$configData['nightStartTime'],"nightEndTime"=>$configData['nightEndTime'],'nightPerson'=>$configData['nightNum']]
        ];
        $setting = [
            'docter_id'=>$docter_id,
            'type'=>$type,
            'status'=>$configData['status'],
            'show_days'=>$configData['showDayNumber'],
            'service_num'=>$configData['serviceNum'],
            'service_times'=>$configData['timeSpan'],
            'service_time'=>json_encode($config)
        ];



        $is_have = DocterSetting::where(['docter_id'=>$docter_id])->value('id');
        if($is_have){
            DocterSetting::where(['docter_id'=>$docter_id])->update($setting);
        } else {
            DocterSetting::insert($setting);
        }
        return  apiReturn(200,'ok');
    }

    public function getDocterSetting()
    {
        $docter_id = request('docter_id',1);
        $setting = DocterSetting::where(['docter_id'=>$docter_id])->first()->toArray();
        $config = object_array(json_decode($setting['service_time']));

        $status = $setting['status'] ? true: false;
        $configData = [
            'amEndTime'=>$config[1]['amEndTime'],
            'amNum'=>$config[1]['amPerson'],
            'amStartTime'=>$config[1]['amStartTime'],
            'nightEndTime'=>$config[3]['nightEndTime'],
            'nightNum'=>$config[3]['nightPerson'],
            'nightStartTime'=>$config[3]['nightStartTime'],
            'pmEndTime'=>$config[2]['pmEndTime'],
            'pmNum'=>$config[2]['pmPerson'],
            'pmStartTime'=>$config[2]['pmStartTime'],
            'serviceNum'=>$setting['service_num'],
            'showDayNumber'=>$setting['show_days'],
            'status'=>$status,
            'timeSpan'=>$setting['service_times'],
        ];


//        configData: {
//                amEndTime: "11:30",    //上午结束时间  string
//        amNum: 20,  //上午号源 Num
//        amStartTime: "09:00",   //上午开始时间  string
//        nightEndTime: "19:30",    //晚上结束时间   string
//        nightNum: 8,  //晚上号源  num
//        nightStartTime: "18:30",   //晚上开始时间 staring
//        pmEndTime: "16:00",   //下午结束时间   string
//        pmNum: 20,   //下午号源   num
//        pmStartTime: "13:30",   //下午开始时间  string
//        serviceNum: 2,    //同时服务人数   Num
//        showDayNumber: 7,   //可预约服务天数  Num
//        status: false,   //  是否开启  true false
//        timeSpan: "15",   // 就诊时长  string
//      },

        return apiReturn(200,'ok',$configData);

    }

    //获取用户信息
    public function getScheduleInfo()
    {
        $docter_id = request('id');
        $org_id = request('org_id');
        $is_docter = CdmsUsers::where('docter_id',$docter_id)->first();
        if(empty($org_id) && empty($docter_id)){
            return json_encode(['status'=>601,'msg'=>'缺少必要参数','data'=>'']);
        }
        $role = 1;
        if($is_docter){
            $role = 2;
        }
        $lists =[];
        if($role == 1){
            $ids = DocterOrganization::where(['organization_id'=>$org_id])->pluck('docter_id')->toArray();
            $list = Docter::whereIn('id',$ids)->get(['id','name']);
            foreach ($list as $val){
                $lists[] = ['value'=>$val->id,'label'=>$val->name];
            }
            $name = Organization::where('id',$org_id)->value('name');
            $user_id = $org_id;
        } else {
            $ids = DocterOrganization::where(['docter_id'=>$docter_id])->pluck('organization_id');
            $list = Organization::whereIn('id',$ids)->get(['id','name']);
            foreach ($list as $val){
                $lists[] = ['value'=>$val->id,'label'=>$val->name];
            }
            $name = Docter::where('id',$docter_id)->value('name');
            $user_id = $docter_id;
        }
        $data['user_id'] = $user_id;
        $data['name'] = $name;
        $data['role'] = $role;
        $data['list'] = $lists;
        return (json_encode(['code'=>200,'msg'=>'ok','data'=>$data]));
    }

    //获取图文订单
    public function get_chat_order()
    {
        $org_id = 1;
//        $docter_id = 1;
        $docter_id = request('docter_id');
        if(empty($docter_id)){
            return json_encode(['status'=>601,'msg'=>'缺少必要参数','data'=>'']);

        }

        $list = Order::where(['organization_id'=>$org_id,'docter_id'=>$docter_id,'order_status'=>3])->with('orderUser')->distinct('user_id')->get('user_id');
        $user_list = [];
        foreach ($list as $val){
            $user_list[] = [
                'id'=>$val->user_id,
                'avatar'=>$val->orderUser->avatar,
                'name'=>$val->orderUser->nickname,
            ];
        }
        $data['docter'] =  Docter::where('id',$docter_id)->first(['id','avatar','name']);
        $data['order_list'] = $user_list;
        return  (json_encode(['code'=>200,'msg'=>'ok','data'=>$data]));
    }

    public function get_month_schedule()
    {
        $date  = request('date');
        $start_time = strtotime($date);
        //$start_time = strtotime(date('Y-m',time()));
        $month_day = date("t",$start_time);
        $types = [1=>1,2=>2,3=>3];

        $status = [1=>true,2=>'other',3=>false];

        for($i=0;$i<$month_day;$i++){
              $now_time = $start_time + $i*86400;
              $now_date = date('Y-m-d',$now_time);
              $week = date('N',$now_time);
              $arr = [
                  ['status'=>false,'type'=>1],
                  ['status'=>true,'type'=>2],
                  ['status'=>false,'type'=>3],
              ];
              if($i%2 == 0){
                  $arr = [
                      ['status'=>false,'type'=>1],
                      ['status'=>true,'type'=>2],
                      ['status'=>true,'type'=>3],
                  ];
              }

            if($i%3 == 0){
                $arr = [
                    ['status'=>true,'type'=>1],
                    ['status'=>'other','type'=>2],
                    ['status'=>false,'type'=>3],
                ];
            }

            if($i%3 == 0){
                $arr = [
                    ['status'=>'other','type'=>1],
                    ['status'=>true,'type'=>2],
                    ['status'=>false,'type'=>3],
                ];
            }
            $all_time[] = ['date'=>($i+1),'day'=>$now_date,'schedulelingList'=>$arr,'week'=>$week];
        }
        return apiReturn(200,'ok',$all_time);
    }


    //获取周排班模板
    public function getWeekSchedule()
    {
        $docter_id = request('docter_id',1);
        $org_id = request('org_id',1);
        $type = request('type',2);
        $role = request('role',2);
        if(empty($docter_id) || empty($type)){
            return apiReturn(604,'缺少必要参数');
        }

        $docter_id = 1;
        $docter_setting = DocterSetting::where(['docter_id'=>$docter_id,'type'=>$type])->first();

        //周字段映射
        $week_arr = ['monday','tuesday','wednesday','thursday','friday','saturday','sunday'];
        $data = [
            [
                'date'=>"上午",
                'monday'=>false,
                'tuesday'=>false,
                'wednesday'=>false,
                'thursday'=>false,
                'friday'=>false,
                'saturday'=>false,
                'sunday'=>false,
            ],
            [
                'date'=>"下午",
                'monday'=>false,
                'tuesday'=>false,
                'wednesday'=>false,
                'thursday'=>false,
                'friday'=>false,
                'saturday'=>false,
                'sunday'=>false,
            ],
            [
                'date'=>"晚上",
                'monday'=>false,
                'tuesday'=>false,
                'wednesday'=>false,
                'thursday'=>false,
                'friday'=>false,
                'saturday'=>false,
                'sunday'=>false,
            ]
        ];
        if($role == 2){
            for ($i=0;$i<6;$i++){
                for($j=0;$j<=2;$j++){
                    $is_self_have = WeekSchedule::where(['docter_id'=>$docter_id,'schedule_type'=>$type,'organization_id'=>$org_id,'week'=>$i+1])->count();
                    $is_other_have = WeekSchedule::where(['docter_id'=>$docter_id,'schedule_type'=>$type,'week'=>$i+1])->where('organization_id','!=',$org_id)->count();
                    if($is_self_have){
                        $data[$j][$week_arr[$i]] = true;
                    }
                    if($is_other_have){
                        $data[$j][$week_arr[$i]] = 'other';
                    }
                }
            }
        } else {
            for ($i=0;$i<6;$i++){
                for($j=0;$j<=2;$j++){
                    $is_self_have = WeekSchedule::where(['docter_id'=>$docter_id,'schedule_type'=>$type,'organization_id'=>$org_id,'week'=>$i+1])->count();
                    $is_other_have = WeekSchedule::where(['docter_id'=>$docter_id,'schedule_type'=>$type,'week'=>$i+1])->where('docter_id','!=',$docter_id)->count();
                    if($is_self_have){
                        $data[$j][$week_arr[$i]] = true;
                    }
                    if($is_other_have){
                        $data[$j][$week_arr[$i]] = 'other';
                    }
                }
            }
        }

        $name = Docter::where('id',$docter_id)->value('name');

        $shcedule_data['docter'] = $data;
        $shcedule_data['name'] = $name;

        $shcedule_data['role'] = $role;
        $shcedule_data['user_id'] = $docter_id;

        return apiReturn(200,'ok',$shcedule_data);
    }

    //设置周排班模板
    public function setWeekSchedule()
    {
        $docter_id = request('docter_id',1);
        $org_id = request('org_id',1);
        $type = request('type',2);
        if(empty($docter_id) || empty($org_id) || empty($type)){
            return apiReturn(601,'缺少必要参数');
        }
        $docter_setting = DocterSetting::where(['docter_id'=>$docter_id])->first();
        $data = [
            [
                'date'=>"上午",
                'monday'=>false,
                'tuesday'=>true,
                'wednesday'=>false,
                'thursday'=>false,
                'friday'=>true,
                'saturday'=>false,
                'sunday'=>false,
            ],
            [
                'date'=>"下午",
                'monday'=>false,
                'tuesday'=>false,
                'wednesday'=>false,
                'thursday'=>false,
                'friday'=>false,
                'saturday'=>true,
                'sunday'=>false,
            ],
            [
                'date'=>"晚上",
                'monday'=>true,
                'tuesday'=>true,
                'wednesday'=>false,
                'thursday'=>false,
                'friday'=>false,
                'saturday'=>false,
                'sunday'=>false,
            ]
        ];
        if(!empty($docter_setting)){
            $time_period = object_array(json_decode($docter_setting->service_time));
            $times[] = TimePeriod::where(['docter_id'=>$docter_id])->whereBetween('end_time_period',[intval($time_period[0]['startTime']),intval($time_period[0]['endTime'])])->pluck('id')->toArray();
            $times[] = TimePeriod::where(['docter_id'=>$docter_id])->whereBetween('end_time_period',[intval($time_period[1]['startTime']),intval($time_period[1]['endTime'])])->pluck('id')->toArray();
            $times[] = TimePeriod::where(['docter_id'=>$docter_id])->whereBetween('end_time_period',[intval($time_period[2]['startTime']),intval($time_period[2]['endTime'])])->pluck('id')->toArray();
        }


        $week_data = [
            'schedule_type'=>$type,
            'organization_id'=>$org_id,
            'docter_id'=>$docter_id
        ];
        $k = 0;
        DB::beginTransaction();
//        $data[0] = array_values(object_array(json_decode($data[0])));
//        $data[1] = array_values(object_array(json_decode($data[1])));
//        $data[2] = array_values(object_array(json_decode($data[2])));


        $data[0] = array_values($data[0]);
        $data[1] = array_values($data[1]);
        $data[2] = array_values($data[2]);
        try {
            for($i=0;$i<=2;$i++){
                $schedule_data = $data[$i];
                foreach ($schedule_data as $key=>$schedule){
                    if($key == 0) continue;
                    $week_data ['type'] = $i+1;
                    $week_data ['week'] = $key;
                    if($schedule == true){
//                        echo '时间列类型'.($i+1).'----'.$key.'星期数'.'<br>';
                        foreach ($times[$i] as $id){
                            $week_data['time_period_id'] = $id;
                            $is_have = WeekSchedule::where(['docter_id'=>$docter_id,'organization_id'=>$org_id,'schedule_type'=>$type,'type'=>$i+1,'week'=>$key])->where('time_period_id',$id)->value('id');
                            $is = $is_have?'有':'沒有';
//                            echo '时间段id'.$id.'----'.$is.'</br>';
                            if($is_have) continue;
                            $k++;
                            WeekSchedule::insert($week_data);
                        }
                    } else {
                        $is_have = WeekSchedule::where(['docter_id' => $docter_id, 'organization_id' => $org_id, 'schedule_type' => $type,'type'=>$i+1,'week'=>$key])->whereIn('time_period_id', $times[$i])->value('id');
                        if($is_have) WeekSchedule::where(['docter_id' => $docter_id, 'organization_id' => $org_id, 'schedule_type' => $type,'type'=>$i+1,'week'=>$key])->whereIn('time_period_id', $times[$i])->delete();
                    }

                }
            }
            DB::commit();
        } catch (\Exception $e){
            DB::rollBack();
            return apiReturn(602,$e->getLine().'行'.$e->getMessage());
        }
        return apiReturn(200,'ok',$k);
    }
}
